/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/gnome.hpp

    Copyright © 2014, 2016—2017, 2019 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later

    ---------------------------------------------------------------------- copyright and license ---
*/

/**
    @file
    Gnome wrappers interface.
**/

#ifndef _GNOME_HPP_
#define _GNOME_HPP_

#include <gio/gio.h>
#include <giomm/dbusproxy.h>

#include "base.hpp"

namespace tapper {
namespace gnome {

    // ---------------------------------------------------------------------------------------------
    // input_source_manager_t
    // ---------------------------------------------------------------------------------------------

    class input_source_manager_t : public object_t {

        public:

            input_source_manager_t();
            ~input_source_manager_t();

            strings_t   keyboard_layouts();
            void        activate_layout( uint_t idx, bool bell = false );

        private:

            void     _reset();
            string_t _eval( string_t const & jscript );

        private:

            Glib::RefPtr< Gio::DBus::Proxy >   _bus;

    }; // class input_source_manager_t

    typedef ptr_t< input_source_manager_t >  input_source_manager_p;

}; // namespace gnome
}; // namespace tapper

#endif // _GNOME_HPP_

// end of file //
