/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/interceptor-li.hpp

    Copyright © 2014, 2016—2017, 2019 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later

    ---------------------------------------------------------------------- copyright and license ---
*/

#ifndef _INTERCEPTOR_LI_HPP_
#define _INTERCEPTOR_LI_HPP_

#include "base.hpp"
#include "interceptor.hpp"
#include "li.hpp"

namespace tapper {
namespace interceptor {

// -------------------------------------------------------------------------------------------------
// interceptor::li_t
// -------------------------------------------------------------------------------------------------

class li_t : public object_t, public interceptor_t {

    public :

        explicit li_t();
        ~li_t();

        virtual string_t            type()                       override;
        virtual key_range_t const & key_range()                  override;
        virtual key_names_t const & key_names()                  override;
        virtual key_codes_t const & key_codes()                  override;
        virtual key_t               key( string_t const & name ) override;
        virtual void                start()                      override;
        virtual void                stop()                       override;

    protected :

        virtual string_t _key_name( key_t key ) override;

    private :

        void _on_intercept( libinput_event * event );

    private :

        static key_range_t const    _range;
        li::context_t               _context;

}; // class li_t

}; // namespace interceptor
}; // namespace tapper

#endif // _INTERCEPTOR_LI_HPP_

// end of file //
