/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/layouter-x.hpp

    Copyright © 2014, 2016—2017, 2019 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later

    ---------------------------------------------------------------------- copyright and license ---
*/

#ifndef _LAYOUTER_X_HPP_
#define _LAYOUTER_X_HPP_

#include "base.hpp"

#include "layouter.hpp"
#include "x.hpp"

namespace tapper {
namespace layouter {

// -------------------------------------------------------------------------------------------------
// x_t
// -------------------------------------------------------------------------------------------------

/**
    X layouter.

    Implements layouter_t intefface via Xkb.
**/
class x_t : public object_t, public layouter_t {

    public :

        x_t();
        string_t type() override;
        uint_t layout_max() override;
        time_t get_autorepeat_delay();
        strings_t layouts() override;
        void activate( uint_t layout ) override;

    private :

        x::display_t    _display;
        x::kb_t         _kb;

}; // class x_t

}; // namespace layouter
}; // namespace tapper

#endif // _LAYOUTER_X_HPP_

// end of file //
